import { BasicMetaSysProps, Link, MakeRequest, DefaultElements } from '../common-types';
import { ContentfulEnvironmentTemplateApi } from '../create-environment-template-api';
import { ContentType } from './content-type';
import { EditorInterface } from './editor-interface';
export declare type Hint = {
    operation: 'renameFieldId';
    fieldId: string;
    previousFieldId: string;
};
export interface EditorInterfaceTemplate extends Omit<EditorInterface, 'sys'> {
    contentTypeTemplate: Link<'ContentTypeTemplate'>;
}
export interface ContentTypeTemplate extends Omit<ContentType, 'sys'> {
    id: string;
    basedOn?: {
        space: Link<'Space'>;
        environment: Link<'Environment'>;
        contentType: Link<'ContentType'>;
    };
    hints?: Array<Hint>;
}
export declare type EnvironmentTemplateProps = {
    sys: BasicMetaSysProps & {
        version: number;
    };
    name: string;
    description?: string;
    versionName: string;
    versionDescription?: string;
    entities: {
        contentTypeTemplates: Array<ContentTypeTemplate>;
        editorInterfaceTemplates: Array<EditorInterfaceTemplate>;
    };
};
export declare type CreateEnvironmentTemplateProps = Omit<EnvironmentTemplateProps, 'sys'>;
export declare type EnvironmentTemplate = EnvironmentTemplateProps & DefaultElements<EnvironmentTemplateProps> & ContentfulEnvironmentTemplateApi;
export declare function wrapEnvironmentTemplate(makeRequest: MakeRequest, data: EnvironmentTemplateProps, organizationId: string): EnvironmentTemplate;
export declare const wrapEnvironmentTemplateCollection: (makeRequest: MakeRequest, data: import("../common-types").CursorPaginatedCollectionProp<EnvironmentTemplateProps>, organizationId: string) => import("../common-types").CursorPaginatedCollection<EnvironmentTemplate, EnvironmentTemplateProps>;
